Imports Microsoft.VisualBasic
Imports System
Imports developwithpassion.bdd
Imports developwithpassion.bdd.contexts
Imports developwithpassion.bdd.mbunit.standard.observations

Namespace Domain.Specs
	Public Class CommandParserSpecs
		Public MustInherit Class concern
			Inherits observations_for_a_sut_without_a_contract(Of CommandParser)
            Private c As context = AddressOf context
            Private Sub context()
                saleEventListener = the_dependency(Of ISaleEventListener)()
            End Sub
			Protected Shared saleEventListener As ISaleEventListener
            Protected Shared end_sale_message As String
        End Class

		Public Class when_interpreting_an_new_sale
			Inherits concern
			Private c As context = Function() end_sale_message = "Command:NewSale"

            Private b As because = AddressOf because
            Private Sub because()
                sut.Parse(end_sale_message)
            End Sub

            Private should_notify_listener_of_a_new_sale As it = Function() saleEventListener.received(AddressOf saleEventListenerReceived)
            Private Sub saleEventListenerReceived(ByVal x As ISaleEventListener)
                x.NewSaleInitiated()
            End Sub

		End Class

		Public Class when_interpreting_an_end_sale
			Inherits concern
			Private c As context = Function() end_sale_message = "Command:EndSale"

            Private b As because = AddressOf because
            Private Sub because()
                sut.Parse(end_sale_message)
            End Sub

            Private should_notify_listner_to_complete_the_sale As it = Function() saleEventListener.received(AddressOf salesEventListenerReceived)
            Private Sub salesEventListenerReceived(ByVal x As ISaleEventListener)
                x.SaleCompleted()
            End Sub
        End Class

		Public Class when_interpreting_an_item_being_entered
			Inherits concern
            Private c As context = AddressOf context
            Private Sub context()
                end_sale_message = "Input: Barcode=100008888559, Quantity=1"
                expected_itemid = New ItemId("100008888559")
                expected_quantity = New Quantity(1)
            End Sub

            Private b As because = AddressOf because
            Private Sub because()
                sut.Parse(end_sale_message)
            End Sub

            Private should_notify_listener_of_item_and_quantity_entered As it = Function() saleEventListener.received(AddressOf salesEventListenerReceived)
            Private Sub salesEventListenerReceived(ByVal x As ISaleEventListener)
                x.ItemEntered(expected_itemid, expected_quantity)
            End Sub

			Private Shared expected_itemid As ItemId
			Private Shared expected_quantity As Quantity
		End Class
	End Class
End Namespace