Imports Microsoft.VisualBasic
Imports System.Collections.Generic

Namespace Domain
	Public Class CommandParser
		Private Const EndSaleCommand As String = "EndSale"
		Private ReadOnly saleEventListener As ISaleEventListener
		Private Const Input As String = "Input"
		Private Const StartSaleCommand As String = "NewSale"

		Public Sub New(ByVal saleEventListner As ISaleEventListener)
			Me.saleEventListener = saleEventListner
		End Sub

		Public Sub Parse(ByVal messageFromDevice As String)
			Dim command = messageFromDevice.Split(":"c)
			Dim commandType = command(0).Trim()
			Dim commandBody = command(1).Trim()
			If Input.Equals(commandType) Then
				ProcessInputCommand(commandBody)
			Else
				ProcessCommand(commandBody)
			End If
		End Sub

		Private Sub ProcessCommand(ByVal commandBody As String)
			If EndSaleCommand.Equals(commandBody) Then
				saleEventListener.SaleCompleted()
			ElseIf StartSaleCommand.Equals(commandBody) Then
				saleEventListener.NewSaleInitiated()
			End If
		End Sub

		Private Sub ProcessInputCommand(ByVal commandBody As String)
			Dim arguments = New Dictionary(Of String, String)()
			Dim commandArgs = commandBody.Split(","c)
			For Each argument In commandArgs
				Dim argNameValues = argument.Split("="c)
				arguments.Add(argNameValues(0).Trim(), argNameValues(1).Trim())
			Next argument

			Dim barcode As String = arguments("Barcode")
			Dim quantity = Integer.Parse(arguments("Quantity"))

			saleEventListener.ItemEntered(New ItemId(barcode), New Quantity(quantity))
		End Sub
	End Class
End Namespace