Imports Microsoft.VisualBasic
Imports System
Namespace Domain
	Public Class Register
		Implements ISaleEventListener
		Private ReadOnly receiptReceiver As IReceiptReceiver
		Private ReadOnly productCatalog As IProductCatalog
		Private Shared ReadOnly nullSale As Sale = New NullSale()
		Private currentSale As Sale



		Public Sub New(ByVal receiver As IReceiptReceiver, ByVal productCatalog As IProductCatalog)
			Me.receiptReceiver = receiver
			Me.productCatalog = productCatalog
			currentSale = nullSale
		End Sub

		Public Sub SaleCompleted() Implements ISaleEventListener.SaleCompleted
			currentSale.SendReceiptTo(receiptReceiver)
		End Sub

		Public Sub NewSaleInitiated() Implements ISaleEventListener.NewSaleInitiated
			currentSale = New Sale()
		End Sub

		Public Sub ItemEntered(ByVal itemId As ItemId, ByVal quantity As Quantity) Implements ISaleEventListener.ItemEntered
			Dim productDescription = productCatalog.ProductDescriptionFor(itemId)
			currentSale.PurchaseItemWith(productDescription)
		End Sub
	End Class
End Namespace