Imports System
Imports System.Collections.Generic

Namespace Domain
    Public Class Sale
        Private ReadOnly itemPurchased As New List(Of ProductDescription)()

        Public Overridable Sub SendReceiptTo(ByVal receiptReceiver As IReceiptReceiver)
            Dim closure As New ComputeTotalClosure With {.Total = New Money(0D)}

            itemPurchased.ForEach(New Action(Of ProductDescription)(AddressOf closure.AddItemUnitPriceToTotal))
            receiptReceiver.ReceiveTotalDue(closure.Total)
        End Sub

        Private Class ComputeTotalClosure
            Public Total As Money

            Public Sub AddItemUnitPriceToTotal(ByVal item As ProductDescription)
                Total += item.UnitPrice
            End Sub
        End Class

        Public Sub PurchaseItemWith(ByVal description As ProductDescription)
            itemPurchased.Add(description)
        End Sub
    End Class
End Namespace